
#define NAME "./.application"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

int exec(char *cmd, char *const args[])
{
	pid_t child;
	if (!(child = fork())) {
		execvp(cmd, args);
		return 0;
	}
	return 0;
}

int main(int argc, const char *argv[])
{
	if (argc != 2) {
		return 1;
	}
	
	int fd = open(argv[0], O_RDONLY);
	if (fd < 3) {
		//printf("Can't open file: %s\n", strerror(errno));
		return errno;
	}
	
	/* init size and offset */
	size_t size = atoi(argv[1]);
	off_t offset = (off_t) size;
	
	if (lseek(fd, -offset, SEEK_END) == (off_t)-1) {
		//printf("Can't seek file: %s\n", strerror(errno));
		return errno;
	}
	
	/* prepare buffer */
	char *elf = malloc(size);
	memset(elf, '\0', size);
	
	/* read from self */
	if (read(fd, elf, size) != (ssize_t) size) {
		//printf("Can't read file: %s\n", strerror(errno));
		return errno;
	}
	
	/* create file, open and write to it */
	mode_t mode = S_IRUSR | S_IRGRP | S_IROTH | S_IXUSR | S_IXGRP | S_IXOTH;
	char *bin = NAME;
	int ed = open(bin, O_TRUNC | O_CREAT | O_WRONLY, mode);
	
	if (ed < 3) {
		//printf("Can't open file: %s\n", strerror(errno));
		return errno;
	}
	
	if (write(ed, elf, size) != (ssize_t) size) {
		//printf("Can't write file: %s\n", strerror(errno));
		return errno;
	}
	
	close(ed);
	close(fd);
	
	/* exec */
	char *const cmd = bin;
	char *const args[] = {cmd, NULL};
	exec(cmd, args);
	
	return 0;
}

